SipHash< C, D, T_128bit > Class Template Reference

SipHash message authentication code. More...

`#include <siphash.h>`

Inheritance diagram for SipHash< C, D, T_128bit >:

## Public Member Functions

| SipHash ()
| Create a SipHash.
| SipHash (const byte *key, unsigned int length)
| Create a SipHash.
Public Member Functions inherited from SipHash_Base< 2, 4, false >
virtual unsigned int | DigestSize () const
| Provides the digest size of the hash.
virtual size_t | MinKeyLength () const
| Returns smallest valid key length.
virtual size_t | MaxKeyLength () const
| Returns largest valid key length.
virtual size_t | DefaultKeyLength () const
| Returns default key length.
virtual size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm.
virtual IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
virtual void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message.
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Static Public Member Functions inherited from SipHash_Base< 2, 4, false >
static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from SipHash_Info< T_128bit >
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from FixedKeyLength< 16 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| The default key length for the algorithm provided by a static function.
Static Public Attributes inherited from SipHash_Info< T_128bit >
static const int | DIGESTSIZE = (T_128bit ? 16 : 8)
Static Public Attributes inherited from FixedKeyLength< 16 >
static const int | KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant.
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant.
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant.
static const int | IV_LENGTH
| The default IV length used by the algorithm provided as a constant.

## Detailed Description

template<unsigned int C = 2, unsigned int D = 4, bool T_128bit = false>
class SipHash< C, D, T_128bit >

SipHash message authentication code.

Template Parameters

  C | the number of compression rounds
  D | the number of finalization rounds
  T_128bit | flag indicating 128-bit (true) versus 64-bit (false) digest size

SipHash computes a 64-bit or 128-bit message authentication code from a variable-length message and 128-bit secret key. It was designed to be efficient even for short inputs, with performance comparable to non-cryptographic hash functions.

To create a SipHash-2-4 object with a 64-bit MAC use code similar to the following.

      SecByteBlock key(16);
      prng.GenerateBlock(key, key.size());

      SipHash<2,4,false> hash(key, key.size());
      hash.Update(...);
      hash.Final(...);

To create a SipHash-2-4 object with a 128-bit MAC use code similar to the following.

      SecByteBlock key(16);
      prng.GenerateBlock(key, key.size());

      SipHash<2,4,true> hash(key, key.size());
      hash.Update(...);
      hash.Final(...);

See also
  Jean-Philippe Aumasson and Daniel J. Bernstein SipHash: a fast short-input PRF

Since
  Crypto++ 6.0

Definition at line 142 of file siphash.h.

## Constructor & Destructor Documentation

## SipHash() [1/2]

template<unsigned int C = 2, unsigned int D = 4, bool T_128bit = false>

SipHash< C, D, T_128bit >::SipHash | ( |  | ) |

inline

Create a SipHash.

Definition at line 146 of file siphash.h.

## SipHash() [2/2]

template<unsigned int C = 2, unsigned int D = 4, bool T_128bit = false>

SipHash< C, D, T_128bit >::SipHash | ( | const byte * | key,
|  | unsigned int | length )

inline

Create a SipHash.

Parameters

  key | a byte array used to key the cipher
  length | the size of the byte array, in bytes

Definition at line 151 of file siphash.h.

The documentation for this class was generated from the following file:

- siphash.h